/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <gtk/gtk.h>
#include <procxml.h>
#include "ctree.h"
#include "powertweak.h"

extern char* getlocalesuffixed( char* filename );

extern void Create_XML_SubTree(GtkCTree * tree, GtkCTreeNode * parent, struct menuitem *menuitem);

void free_dataptr (gpointer data)
{
	free(data);
}


void selected_row_callback (GtkCTree *ctree, GtkCTreeNode *node, gpointer __unused foo)
{
//FIXME:
// Yeuch!  The same structure can be used in three different ways.
// And we can only find out the type of structure, by reading it.
// This *may* cause problems.
 
	struct treenode *event;
	struct PROC_treenode *event_PROC;

	event = gtk_ctree_node_get_row_data (GTK_CTREE(ctree), node);
	if (event != NULL) {

		switch (event->node_type) {
			case node_PROC_XML:
				event_PROC = gtk_ctree_node_get_row_data (GTK_CTREE(ctree), node);
				select_XML_item(event_PROC->node_xmlmenu);
				break;

			default:
				break;
		}
	}
}






/*
 *
 * This is the routine which creates the top level of the tree.
 * It calls all the functions that create all the 'branches' on the tree.
 *
 */

void CreateTree(GtkWidget *scrolled_win)
{
	GtkWidget *tree;
	GtkCTreeNode *item_new;
	gchar titlearray[20];
	gchar *title[1];
	
	struct menuitem *menuitem;

	title[0] = titlearray;
    
	/* Create root tree widget */
	tree = gtk_ctree_new(1, 0);

	gtk_clist_set_row_height(GTK_CLIST (tree), 15);
	gtk_ctree_set_line_style (GTK_CTREE (tree), GTK_CTREE_LINES_DOTTED);
	gtk_ctree_set_expander_style (GTK_CTREE (tree), GTK_CTREE_EXPANDER_SQUARE);
	gtk_clist_set_column_width (GTK_CLIST (tree), 0, 150);
	gtk_ctree_set_indent (GTK_CTREE (tree), 15);
	gtk_clist_set_column_auto_resize (GTK_CLIST (tree), 0, TRUE);
	gtk_clist_set_selection_mode (GTK_CLIST (tree), GTK_SELECTION_BROWSE);
	gtk_signal_connect (GTK_OBJECT (tree), "tree_select_row",
			GTK_SIGNAL_FUNC (selected_row_callback), NULL);



	if (xmlroot==NULL)
		init_xml_subsystem_from_file(getlocalesuffixed(XMLFILE));

	menuitem = xmlroot;
	
	while (menuitem!=NULL) {
		/* See if there is anything to add */
		if (menuitem->ActiveCount==0) {
			/* No, there isn't anything */
			menuitem = menuitem->Next;
			continue;
		}
		sprintf (*title, menuitem->Name);
		item_new = gtk_ctree_insert_node (GTK_CTREE(tree), NULL, NULL, title, 0, NULL, NULL, NULL, NULL, FALSE, FALSE);
		gtk_ctree_node_set_selectable (GTK_CTREE (tree), item_new, FALSE);
		Create_XML_SubTree(GTK_CTREE(tree), item_new,menuitem);
		
		menuitem = menuitem->Next;
	}

	
	gtk_container_add (GTK_CONTAINER (scrolled_win), tree);
	gtk_widget_show(tree);
}
