/*
 * Copyright (c) 2000 	Arjan van de Ven <arjan@fenrus.demon.nl>
 *			Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdlib.h>
#include <gtk/gtk.h>
#include "../ctree.h"
#include <procxml.h>


void Create_XML_SubTree(GtkCTree * tree, GtkCTreeNode * parent, struct menuitem *menuitem)
{
	GtkCTreeNode *item_new;
	struct PROC_treenode *dataptr;

	if (menuitem == NULL) {
		printf("Menuitem == NULL\n");
		return;
	}
	menuitem = menuitem->Submenus;	/* it pointed at the main "Menu", now it points to the
					   SubMenu */

	while (menuitem != NULL) {
		/* Check if there is anything to add */
		if (menuitem->ActiveCount==0) {
			menuitem = menuitem->Next;
			continue;
		}
		item_new = gtk_ctree_insert_node(tree, parent, NULL, &menuitem->Name, 0,
						 NULL, NULL, NULL, NULL, TRUE, FALSE);

		//FIXME: The following malloc is never freed.
		//FIXME: If the following malloc fails, the nodes that succeed are not freed.
		dataptr = malloc(sizeof(struct PROC_treenode));
		if (dataptr == NULL) {
			printf("Can't malloc memory for node!\n");
		} else {
			dataptr->node_type = node_PROC_XML;
			dataptr->node_xmlmenu = menuitem->Submenus;
			gtk_ctree_node_set_row_data_full(tree, item_new, dataptr, free_dataptr);
		}

		menuitem = menuitem->Next;
	}
}
