/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <gtk/gtk.h>
#include <string.h>
#include "powertweak.h"

GtkText *TweakInfoTextPtr=0;

void clear_tweak_info(void)
{
	if (TweakInfoTextPtr!=0) {
		gtk_text_freeze (TweakInfoTextPtr);
		gtk_text_set_point (TweakInfoTextPtr, 0);
		gtk_text_forward_delete (TweakInfoTextPtr, gtk_text_get_length(TweakInfoTextPtr));
		gtk_text_thaw(TweakInfoTextPtr);
	}
}


void modify_tweak_info (GtkWidget __unused *widget, const char *description_src)
{
	static char enable_best[]="Enabled is best.";
	static char disable_best[]="Disabled is best.";
	static char unknown_best[]="Unknown which setting is best, please report your findings.";

	char description_dest[512];
	const char *descriptionptr;

	//FIXME: Allow for inbuilt AND a normal description.
	switch (description_src[0]) {

		case '0':
			strncpy (description_dest, disable_best, strlen(disable_best));
			descriptionptr = description_dest;
			description_dest[strlen(disable_best)]='\0';
			break;

		case '1':
			strncpy (description_dest, enable_best, strlen(enable_best));
			descriptionptr = description_dest;
			description_dest[strlen(enable_best)]='\0';
			break;
	
		case '?':
			strncpy (description_dest, unknown_best, strlen(unknown_best));
			descriptionptr = description_dest;
			description_dest[strlen(unknown_best)]='\0';
			break;
	
		default:
			descriptionptr = description_src;
			break;
	}

	clear_tweak_info();
	gtk_text_insert (TweakInfoTextPtr, NULL, NULL, NULL, descriptionptr, strlen(descriptionptr));
}
