/* Copyright 1999-2000 Red Hat, Inc.
 *
 * Florian La Roche <Florian.LaRoche@redhat.de>
 *
 * This software may be freely redistributed under the terms of the GNU
 * public license.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include "rhutil.h"

int
NewContent (rhconfig_t *c, char *buf, size_t n)
{
	/* XXX if (!do_you_want_to_accept_new_content()) return 1; */
	RH_FREE (c->buf);
	c->buf = buf;
	c->n = n;
	return 0;
}

int
NewContent2 (rhconfig_t *c, rh_list *list)
{
	size_t n;
	char *buf = List2Buf (list, &n);

	if (NewContent (c, buf, n)) {
		free (buf);
		return 1;
	}
	rh_list_delete (list, 1);
	return 0;
}
