/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <errno.h>
#include "powertweak.h"

extern char fileexists(const char *filename);

char *read_char_from_proc_file(const char *filename, int element)
{
	FILE *procfh;
	char contents[80];
	char *elementptr=NULL;
	char *endptr;
	int i;

	if ((procfh = fopen (filename, "rb")) == NULL)
		return (FALSE);

	fgets (contents, sizeof(contents), procfh);

	if (fclose (procfh) != 0)
		fprintf (stderr, "Error closing file : %s\t%s\n", filename, sys_errlist[errno]);

	elementptr = contents;

	if (element != -1) {
		for (i=0 ; i<element ; i++) {
			while (*elementptr != '\t')
				elementptr++;
			elementptr++;
		}
	}
	endptr = elementptr;
	while (*endptr!='\t' && *endptr!='\n' && *endptr!=' ')
		endptr++;
	*endptr='\0';
	return elementptr;
}

//FIXME: Code duplication.
unsigned int read_int_from_proc_file(const char *filename, int element)
{

	FILE *procfh;
	char contents[64];
	char *elementptr=NULL;
	int i;

	if ((procfh = fopen (filename, "rb")) == NULL)
		return (FALSE);

	fgets (contents, sizeof(contents), procfh);

	if (fclose (procfh) != 0)
		fprintf (stderr, "Error closing file : %s\t%s\n", filename, sys_errlist[errno]);

	elementptr = contents;

	if (element != -1) {
		for (i=0 ; i<element ; i++) {
			while (*elementptr != '\t')
				elementptr++;
			elementptr++;
		}
	}

	return (atoi(elementptr));
}
